Attribute VB_Name = "LocalHistory"
Public Type HistDisplayType
  DispColor As Long
  dispId As Long
  devName As String
  prpName As String
  devIndex As Integer
  NumPoints As Integer
  TotalPoints As Long
  ContextName As String
  ServerName As String
  deviceName As String
  'PropIndex As Integer
  PropUnits As String
  PropSize As Long
  PropDesc As String
  PropFormatStr As String
  PropMin As Single
  PropMax As Single
  PropGraphType As String
  ndevices As Integer
    ArchiveDataServer As String
    ArchiveHistoryServer As String
    ArchiveProperty As String
    ArrayType As Integer
    XMax As Single
    XMin As Single
    XUnits As String
    RowSize As Integer
End Type

Global HistPrpInfo() As XPropertyQuery
Global ChooserDisplayInfo() As HistDisplayType
Global ClientOcxDisplayInfo() As HistDisplayType, NClientOcxProps%

Type HelpType
    HelpName As String
    HelpContext As String
    HelpServer As String
    HelpProperty As String
End Type
Global HelpNameList(50) As HelpType
Global NHelpNames%

'Global Const MaxTraces = 20
'Global Const MaxPoints = 2000
'Global Const MaxDevs = 1000
'Global devNames(MaxDevs, MaxTraces) As String
'Global HistoryStart&, HistoryStop&, KeepZoom#(3)
'Global HistoryData(MaxPoints, MaxTraces - 1) As FLTINT

Global ACOPCaptionText$(2)

Global ArrayPlotIndex&, RefPlotIndex&, MarkerPlotIndex&, RefMarkerPlotIndex&
Global HistContexts$(), NHistContexts%, HistoryProps$(), NHistoryProps%
Global HistDeviceServers$(), NHistDeviceServers%

Global StartingUp As Boolean

Declare Function GetClassLong Lib "user32" Alias "GetClassLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Global Const GCL_HMODULE As Long = (-16)

Public Sub AddToDeviceList(ClientDataList() As HistDisplayType, NProps%)
'dContext$, DServer$, dName$, dIndex%, PropName$, PropUnits$, PropSize%, PropDesc$, PropMin!, PropMax!)

Dim i%, tmpDeviceName$, rc%

' ADD to the property list data from "client" program....

For i% = 0 To NProps% - 1
    ' ADD to the list.....
    ClientOcxDisplayInfo(NClientOcxProps% + i%) = ClientDataList(i%)

    With ClientOcxDisplayInfo(NClientOcxProps% + i%)
        If Trim(.PropDesc) <> "" Then
            ArchiveForm.ListProps.AddItem str$(i% + 1) + ".  " + .PropDesc '+ " (" + .prpName + ")"
        Else
            ArchiveForm.ListProps.AddItem str$(i% + 1) + ".  " + .PropDesc + " (" + .prpName + ")"
        End If
    End With
Next i%

NClientOcxProps% = NClientOcxProps% + NProps%

'With hstDisplay(NDisplays%)
'    .ContextName = dContext$
'    .ServerName = DServer$
'    .deviceName = dName$
'
'    .devName = tmpDeviceName$
'    .prpName = PropName$
'    .devIndex = dIndex%
'
'
'    '.PropIndex = PropsCombo.ListIndex
'
'    .PropUnits = PropUnits$ 'BSTR(HistPrpInfo(.PropIndex).prpUnits)
'    .PropSize = PropSize% 'HistPrpInfo(.PropIndex).prpSize
'    .PropDesc = PropDesc$
'
'    .PropMin = PropMin!
'    .PropMax = PropMax!
'    .NDevices = NDevs
'End With

End Sub

Function GetDevNamesFromProp(devServer$, devProperty$, devNames$(), NDeviceNames%, nFECDevices%, XPrpQuery As XPropertyQuery) As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim n As Integer, tmpPropSize%
Dim nms() As NAME16
Dim rc As Integer, i%, j%
Dim dev As String
Dim tempPropertySize&
Dim tmpXPrpQuery As XPropertyQuery

' THUS IS JUST A KLUDGE!
' this is the SIZE from the PROPERTY query... (should be the same as from the .NAM query!)

' And get the INFO (min, max....) also....
rc% = GetFullPropertyInformation(devServer, devProperty$, XPrpQuery)
If (rc% And CE_SENDDATA) = CE_SENDDATA Then rc% = 0
If rc Then GoTo exitFunction

n = 0
tempPropertySize& = XPrpQuery.prpSize
If tempPropertySize& > 2 ^ 16 Then
    ' Too big! size is an INTEGER!
    ' must be a spectrum (NO DEVICE NAMES)
    MsgBox "Prop Size Too Big - for an INTEGER! " + str$(tempPropertySize&) + ".  Skipping-Out!"
    GoTo exitFunction
End If

If tempPropertySize& = 1 Then
    ' size is one - don't need names....
    ReDim devNames(0)
    devNames$(0) = "#0"
    j% = 1
    GoTo exitFunction
Else
    ' Try the .NAM property....
    rc% = GetFullPropertyInformation(devServer, devProperty$ + ".NAM", tmpXPrpQuery)
    If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0
    If rc% = 0 And tmpXPrpQuery.prpSize > 0 Then
        ' There IS a .NAM property... everything is FINE...
        tmpPropSize% = CInt(tmpXPrpQuery.prpSize)
        n = tmpPropSize%
    Else
        ' Get the NUMBER OF DEVICES which have been registered....
        ' (should be returned by the .NAM call, if there IS no .NAM property registered...)
        dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
        dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
        rc = T_EXECLINK(devServer, "NDEVICES", dbout, n, dbin, Null, CA_READ, 800)
        
        If n = 1 Then
            ' no registered devices -
            If tempPropertySize& > 1 Then
                ReDim devNames(tempPropertySize&): j% = 0
                For i% = 0 To tempPropertySize& - 1
                    devNames$(i%) = "#" + Format$(i%, "0")
                Next i%
                j% = i%
                GoTo exitFunction
            End If
        Else
            If tempPropertySize& > n Then
                n = tempPropertySize&
            Else
            End If
        End If
    End If
End If

nFECDevices = n            'put this back in so that normal queries would work again P.D.
tmpPropSize% = nFECDevices
XPrpQuery.prpSize = tmpPropSize% 'this is nutty, but it'll pass the info back up

ReDim nms(tmpPropSize%)

dbout.dArrayLength = tmpPropSize%: dbout.dFormat = CF_NAME16
rc = T_EXECLINK(devServer, devProperty + ".NAM", dbout, nms(0), dbin, Null, CA_READ, 3000)
If (rc And CE_SENDDATA) = CE_SENDDATA Then rc = 0
If rc Then GoTo exitFunction
tmpPropSize% = dbout.dArrayLength
ReDim devNames(tmpPropSize%): j% = 0
For i% = 0 To tmpPropSize% - 1
    dev = Trim$(BSTR(nms(i%).nam()))
    If Right$(dev, 1) = "&" And Len(dev) = 16 Then
        i% = i% + 1
        dev = Left$(dev, 15) + Trim$(BSTR(nms(i%).nam()))
    End If
    If Len(dev) > 0 And dev <> "XYZHASQUERYFCN" Then
        devNames(j%) = dev
        j% = j% + 1
    Else
        Exit For
    End If
Next i%
exitFunction:
NDeviceNames% = j%
GetDevNamesFromProp = rc
End Function


