Attribute VB_Name = "fecadmin"
Option Explicit

Type RPCDataStruct
  FecName As String ' 16
  'reserved(4) As Byte
  ExportName As String '16
  EqName As String ' 7
  Context As String '16
  alarmSystem As Integer
End Type
Global RPCDataStructBytes(61) As Byte

Type RPCFecStruct
  Name As String ' 16
  'reserved(2) As Byte
  Port As Integer ' byte * 2
  Network(3) As Byte
  Node(5) As Byte
  ImmediateAddress(5) As Byte
  IP As String ' 16
  'PortOffset as byte
  IPh_addr(3) As Byte
  Prot As Integer
End Type
Global RPCFecStructBytes(59) As Byte

Type RPCFecExStruct
  os As String '12
  desc As String ' [64];
  loc As String ' [32];
  hdw As String ' [32];
  sub As String ' [16];
  resp As String ' [32];
End Type
Global RPCFecExStructBytes(187) As Byte

Sub fillRPCDataBytes(rpcdat As RPCDataStruct)
Dim buf(32) As Byte
BARR buf, rpcdat.FecName
Utils.MEMCPY RPCDataStructBytes(0), buf(0), 16
BARR buf, rpcdat.ExportName
Utils.MEMCPY RPCDataStructBytes(21), buf(0), 16
BARR buf, rpcdat.EqName
Utils.MEMCPY RPCDataStructBytes(37), buf(0), 6
BARR buf, rpcdat.Context
Utils.MEMCPY RPCDataStructBytes(44), buf(0), 16
Utils.MEMCPY RPCDataStructBytes(60), rpcdat.alarmSystem, 2
End Sub

Sub fillRPCFecBytes(rpcfec As RPCFecStruct)
Dim buf(32) As Byte
Dim ipbytes(3) As Byte
Dim i As Integer, p As Integer
Dim seg As String, tmp As String

tmp = rpcfec.IP
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(0) = Val(seg)
tmp = Right$(tmp, Len(tmp) - p)
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(1) = Val(seg)
tmp = Right$(tmp, Len(tmp) - p)
p = InStr(tmp, ".")
seg = Left$(tmp, p - 1)
ipbytes(2) = Val(seg)
seg = Right$(tmp, Len(tmp) - p)
ipbytes(3) = Val(seg)

BARR buf, rpcfec.Name
Utils.MEMCPY RPCFecStructBytes(0), buf(0), 16
Utils.MEMCPY RPCFecStructBytes(19), rpcfec.Port, 2
BARR buf, rpcfec.IP
Utils.MEMCPY RPCFecStructBytes(37), buf(0), 16
Utils.MEMCPY RPCFecStructBytes(53), rpcfec.Port, 1
Utils.MEMCPY RPCFecStructBytes(54), ipbytes(0), 4

End Sub

Sub fillRPCFecExBytes(fecex As RPCFecExStruct)
Dim buf(72) As Byte
BARR buf, fecex.os
Utils.MEMCPY RPCFecExStructBytes(0), buf(0), 12
BARR buf, fecex.desc
Utils.MEMCPY RPCFecExStructBytes(12), buf(0), 64
BARR buf, fecex.loc
Utils.MEMCPY RPCFecExStructBytes(76), buf(0), 32
BARR buf, fecex.hdw
Utils.MEMCPY RPCFecExStructBytes(108), buf(0), 32
BARR buf, fecex.sub
Utils.MEMCPY RPCFecExStructBytes(140), buf(0), 16
BARR buf, fecex.resp
Utils.MEMCPY RPCFecExStructBytes(156), buf(0), 32

End Sub


