#define EXECUTE_METHOD	1
#define ATTACH_METHOD	2
#define DETACH_METHOD	3
#define GETDATA_METHOD	4

typedef struct 
{
	HGLOBAL hMem;
	long type; // is VT_EMPTY ptr is now byte array for cust formats
	long arraySize;
	long blockSize;
	LPSTR custFormat;
}DTYPE;

typedef struct 
{
	short MethodType;
	LPSTR DeviceName;
	LPSTR DeviceProperty;
	LPSTR AccessMode;
	LPSTR AccessRate;
	LPSTR AccessProtocol;
	DTYPE Data;
	DTYPE DataEx;
	LPSTR Status;
	long StatusCode;
	long TimeStamp;
	long hLink;
	short Pending;
	short Grouped;
	void (*callBack)(long hLink);
}DevStruct;

#ifdef __cplusplus
#define F_PREFIX extern "C"
#else
#define F_PREFIX extern
#endif

F_PREFIX void WINAPI InitAcopDll(void);
F_PREFIX long WINAPI DevRequest(DevStruct *ds);
F_PREFIX long WINAPI QueryStockAccessModes(LPSTR * modeArray);
F_PREFIX long WINAPI QueryDataBlockSize(long dimension,char *fmtstr);
F_PREFIX long WINAPI QueryDefaultAccessProtocol(LPSTR *protocol);
