#ifndef RPCALLOC_H_
#define RPCALLOC_H_

extern int debug;
extern int usageCount;
extern int nglobals;
extern HANDLE hDLLWnd;
extern linkType *link;
extern int SyncID;
extern LCLCONTRACT *lclContract;
ElemDataStruct *stdContractAlloc(char *tag,int sizeIn,int sizeOut);
BYTE *stdDataBlockAlloc(char *tag,int size);
LCLCONTRACT *lclStdContractAlloc(char *tag);
void stdContractFree(ElemDataStruct *e);
void stdDataBlockFree(BYTE *d);
void lclStdContractFree(LCLCONTRACT *lc);
#define ContractAlloc(tag,sizeIn,sizeOut,hContract) stdContractAlloc(tag,sizeIn,sizeOut)
#define DataBlockAlloc(tag,size,hBlock) stdDataBlockAlloc(tag,size)
#define lclContractAlloc(tag,hContract) lclStdContractAlloc(tag)
#define ContractFree(e,hContract) stdContractFree(e)
#define DataBlockFree(d,hBlock) stdDataBlockFree(d)
#define lclContractFree(lc,hContract) lclStdContractFree(lc)

#endif // RPCALLOC_H_