#ifndef _SHMALLOC_H_
#define _SHMALLOC_H_
#define hSHARE ((HANDLE)0xffffffff)

#define WM_READ_LCL        (WM_USER+100)

typedef struct 
{
  char dataTag[16];
  int  dirty;
  int  size;
  BYTE *payload;
} shmDataGram;

HANDLE mmfalloc(char *tag,int SizeInBytes,BYTE **lpView,int *mmfFlag);
int mmfInit(void);
shmDataGram *shmGetDataGram(char *tag,int size,HANDLE *h);
int shmSndDataGram(char *tag,BYTE *data,int size,HANDLE *h);
void shmFreeDataGram(shmDataGram *dg,HANDLE h);
BYTE *shmDataBlockAlloc(char *tag,int size,HANDLE *hBlock);
void shmDataBlockFree(BYTE *d,HANDLE hBlock);

#endif // _SHMALLOC_H_
