VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form PROCINFO 
   Caption         =   "watchdog - process info"
   ClientHeight    =   5115
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11280
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5115
   ScaleWidth      =   11280
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CMD_print 
      Caption         =   "&Print"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   960
      TabIndex        =   1
      Top             =   60
      Width           =   855
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid PROCESS_DEF_GRID 
      Height          =   4575
      Left            =   0
      TabIndex        =   0
      Top             =   480
      Width           =   11235
      _ExtentX        =   19817
      _ExtentY        =   8070
      _Version        =   393216
      FixedRows       =   0
      FixedCols       =   0
      GridColor       =   16711680
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
End
Attribute VB_Name = "PROCINFO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    
    With PROCESS_DEF_GRID
        .TextArray(0) = "name"
        .TextArray(2) = "running"
        .AddItem ("started")
        .AddItem ("stopped")
        .AddItem ("auto restart")
        .AddItem ("check heart beat")
        .AddItem ("use NotPostedCheck")
        .AddItem ("main window handle")
        .AddItem ("window handles")
        .AddItem ("pid")
        .AddItem ("process handle")
        .AddItem ("thread id")
        .AddItem ("thread handle")
        .AddItem ("dependcy")
        .AddItem ("#negative checks before restart")
        .AddItem ("log book entry prohibit time")
    End With
            
End Sub

Private Sub formatGrids(g As MSHFlexGrid)
    Dim al As Integer, j As Integer, i As Integer
    With g
        For i = 0 To .Rows - 1
            .Row = i
            .RowHeight(i) = .Height / (.Rows + 1)
            .col = 0: .CellAlignment = flexAlignRightCenter
            .col = 1: .CellAlignment = flexAlignLeftCenter
        Next
        .ColWidth(0) = (.Width - 100) / 4
        .ColWidth(1) = .ColWidth(0) * 3
    End With
End Sub
Private Sub Form_Activate()
    Dim i As Integer, idx As Integer
    
    idx = MAIN.APPLIST.ListIndex
    If idx < 0 Then
        Hide
        Exit Sub
    End If
    
    Call formatGrids(PROCESS_DEF_GRID)
    
    With PROCESS_DEF_GRID
        .TextArray(1) = ProcList(idx).name
        .TextArray(3) = IIf(ProcList(idx).running, "yes", "no")
        If ProcList(idx).started < 0 Then
            .TextArray(5) = "(attached) " + CStr(ProcList(idx).attached)
        Else
            .TextArray(5) = CStr(ProcList(idx).started)
        End If
        .TextArray(7) = IIf(ProcList(idx).stopped < 0, "never", CStr(ProcList(idx).stopped))
        .TextArray(9) = IIf(ProcList(idx).auto_restart, "yes", "no")
        .TextArray(11) = IIf(ProcList(idx).check_hbeat, "yes", "no")
        .TextArray(13) = IIf(ProcList(idx).use_NotPostedCheck, "yes", "no")
        .TextArray(15) = CStr(ProcList(idx).hMainWindow)
        .TextArray(17) = ""
        For i = 1 To ProcList(idx).hwnds.count
            .TextArray(17) = .TextArray(17) + CStr(ProcList(idx).hwnds(i)) + " "
        Next
        .TextArray(19) = ProcList(idx).pid
        .TextArray(21) = ProcList(idx).phandle
        .TextArray(23) = ProcList(idx).tid
        .TextArray(25) = ProcList(idx).thandle
        .TextArray(27) = ProcList(idx).mustBeRunningProcess
        .TextArray(29) = ProcList(idx).maxNotActiveCounter
        .TextArray(31) = ProcList(idx).logBookEntryProhibitTime
    End With
End Sub

Private Sub Form_Resize()
    If WindowState = vbMinimized Then Exit Sub
    With PROCESS_DEF_GRID
        .Width = ScaleWidth - .Left
        .Height = ScaleHeight - .Top
        Call formatGrids(PROCESS_DEF_GRID)
    End With
End Sub

Private Sub CMD_print_Click()
    PrintForm
End Sub
