Attribute VB_Name = "Module1"
Type ALMRECORD
  Context As String
  server As String
  Extension As String
  SeverityLevel As String
  ArchiveLevel As String
  Retention As String
  AlarmLevel As String
  TriggerFile As String
  SubSystem As String
  alarmSystem As String
End Type

Type ALMSYS
  tag As String
  subs As String
  nr  As Integer
End Type

Global NMachines As Integer

Global dbPaths() As String
Global dbContexts() As String
Function getAlarmServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, pth_col%
Dim fn$

fn$ = App.Path + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getAlarmServerInfo = 0
  Exit Function
End If

ReDim dbPaths(NMachines)
ReDim dbContexts(NMachines)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      pth_col = colptr(a$, "PATH")
      done = True
    Else
      dbPaths(i%) = getcol(a$, pth_col)
      dbContexts(i%) = getcol(a$, con_col)
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getAlarmServerInfo = i%
End Function

