VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "ENS Administration"
   ClientHeight    =   3750
   ClientLeft      =   165
   ClientTop       =   780
   ClientWidth     =   8265
   Icon            =   "fecadmin.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3750
   ScaleWidth      =   8265
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame2 
      Caption         =   "Fec Information Panel"
      Height          =   3615
      Left            =   4380
      TabIndex        =   4
      Top             =   90
      Width           =   3795
      Begin VB.TextBox fecInfoText 
         Height          =   3315
         Left            =   60
         MultiLine       =   -1  'True
         TabIndex        =   5
         Top             =   240
         Width           =   3645
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Administration Panel"
      Height          =   3615
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   4245
      Begin VB.ListBox lstDeviceServers 
         Height          =   2400
         Left            =   2130
         TabIndex        =   3
         Top             =   1080
         Width           =   1935
      End
      Begin VB.ListBox lstFecNames 
         Height          =   2400
         Left            =   90
         Sorted          =   -1  'True
         TabIndex        =   2
         Top             =   1080
         Width           =   1935
      End
      Begin VB.ComboBox cmbContexts 
         Height          =   315
         Left            =   90
         Sorted          =   -1  'True
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   480
         Width           =   1965
      End
      Begin VB.Label srvLabel 
         Caption         =   "Registered Device Servers :"
         Height          =   645
         Left            =   2190
         TabIndex        =   8
         Top             =   420
         Width           =   1845
      End
      Begin VB.Label Label2 
         Caption         =   "Available contexts:"
         Height          =   255
         Left            =   150
         TabIndex        =   7
         Top             =   240
         Width           =   1425
      End
      Begin VB.Label Label1 
         Caption         =   "Registered Fecs :"
         Height          =   255
         Left            =   90
         TabIndex        =   6
         Top             =   840
         Width           =   1425
      End
   End
   Begin VB.Menu fecOpts 
      Caption         =   "&Fec Options"
      Begin VB.Menu rmvFec 
         Caption         =   "&Remove FEC"
      End
      Begin VB.Menu addFec 
         Caption         =   "&Add Fec"
      End
   End
   Begin VB.Menu srvOpts 
      Caption         =   "&Device Server Options"
      Begin VB.Menu rmvSrv 
         Caption         =   "&Remove Device Server"
      End
      Begin VB.Menu pngSrv 
         Caption         =   "&Ping Device Server"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim nfecs As Integer, ncontexts As Integer, nservers As Integer
Dim lstFecNamesIndex As Integer
Dim lstDeviceServersIndex As Integer
Dim fecNames() As String
Dim contexts() As String
Dim servers() As String

Sub pingSelectedDeviceServer()
Dim dbout As DBLK
Dim dbin As DBLK
Dim devName As String
Dim devnm As NAME16
Dim rc As Integer, i As Integer, n As Integer
Dim msg$

dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
dbout.dArrayLength = 1: dbout.dFormat = CF_SHORT
devName = "/" + cmbContexts.text + "/" + lstDeviceServers.text
For i = 0 To 3
  rc = T_EXECLINK(devName, "NPROPS", dbout, n, dbin, 0, CA_READ, 500)
  If rc = 0 Then Exit For
Next
Select Case rc
  Case 0:
    msg$ = devName + " is running "
  Case link_not_open, connection_timeout:
    msg$ = devName + " timeout out (not running ?) "
  Case Else:
    msg$ = devName + " : " + RPCERROR(rc)
End Select
MsgBox msg$, vbOKOnly, "Device Server Ping"
End Sub

Private Function prepareFecInfo(f As tine.RPCFECINFO) As String
Dim s As String
Dim rc As Integer
Dim IP As String * 16
Dim ipx(16) As Byte
Dim mac(16) As Byte
Dim hostname As String * 64
Dim Port As Integer, p As Integer, i As Integer
Dim dsc As String, subs As String, tmp As String
dsc = BSTR(f.Description)
If Left$(dsc, 1) = "[" Then
  p = InStr(dsc, "]")
  If p > 0 Then
    tmp = Mid(dsc, 2, p - 2)
    dsc = Right(dsc, Len(dsc) - p)
  End If
End If
s = dsc + vbNewLine
s = s + "OS : " + BSTR(f.os) + vbNewLine
s = s + "Responsible : " + BSTR(f.responsible) + vbNewLine
s = s + "Location : " + BSTR(f.Location) + vbNewLine
subs = BSTR(f.subsystem)
If Len(subs) = 0 And Len(tmp) > 0 Then subs = tmp
s = s + "subsystem : " + subs + vbNewLine
For i = 0 To 2
  rc = GETFECDATA(lstFecNames.text, ipx(0), mac(0), IP, Port)
  DoEvents
  If rc = 0 Then Exit For
Next
If rc = 0 Then
  s = s + "IP Address: " + TrimString(IP) + vbNewLine
  s = s + "Port offset: " + STR(Port) + vbNewLine
End If
rc% = GetHostFromFecName(lstFecNames.text, hostname)
If rc = 0 Then
  p = InStr(hostname, ".") - 1
  If p < 0 Then p = 0
  s = s + "Host : " + Left(hostname, p)
End If
prepareFecInfo = s
End Function

Sub rmvSelectedDeviceServer()
Dim dbout As DBLK
Dim dbin As DBLK
Dim devName As String
Dim devnm As NAME16
Dim rc As Integer, i As Integer
Dim msg$

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
BARR devnm.nam(), lstDeviceServers.text
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
'devName = "ENS/EQP" '+ cmbContexts.text
devName = "ENS/" + cmbContexts.text

msg$ = "Remove Device Server : " + lstDeviceServers.text + vbNewLine
rc = MsgBox(msg$, vbOKCancel, "Remove Entry From ENS")
If rc = vbCancel Then Exit Sub
lstFecNamesIndex = -1
For i = 0 To 2
  rc = T_EXECLINK(devName, "REMOVE", dbout, 0, dbin, devnm, CA_READ + CA_WRITE, 500)
  If rc = 0 Then Exit For
Next
If rc = 0 Then
  lstFecNamesIndex = lstFecNames.ListIndex
Else
  MsgBox RPCERROR(rc)
End If
Call cmbContexts_Click
End Sub

Sub rmvSelectedFec()
Dim dbout As DBLK
Dim dbin As DBLK
Dim devName As String
Dim fecnm As NAME16
Dim rc As Integer, i As Integer
Dim msg$

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME16
BARR fecnm.nam(), lstFecNames.text
dbout.dArrayLength = 0: dbout.dFormat = CF_NULL
devName = "ENS/FEC"

msg$ = "Remove Front End Computer : " + lstFecNames.text + vbNewLine
For i% = 0 To lstDeviceServers.ListCount - 1
  msg$ = msg$ + "            Device Server : " + lstDeviceServers.List(i%) + vbNewLine
Next
rc = MsgBox(msg$, vbOKCancel, "Remove Entry From ENS")
If rc = vbCancel Then Exit Sub
lstFecNamesIndex = -1
For i = 0 To 2
  rc = T_EXECLINK(devName, "REMOVE", dbout, 0, dbin, fecnm, CA_READ + CA_WRITE, 500)
  If rc = 0 Then Exit For
Next
If rc = 0 Then
  lstFecNamesIndex = lstFecNames.ListIndex
Else
  MsgBox RPCERROR(rc)
End If
Call cmbContexts_Click

End Sub

Private Sub addFec_Click()
FecAdder.Show
End Sub

Private Sub cmbContexts_Click()
Dim contxt As String
Dim rc As Integer, i As Integer
contxt = cmbContexts.text
lstFecNamesIndex = 0
If contxt = "DEFAULT" Then contxt = ""
For i = 0 To 2
  rc = GetFecsFromNameServer(contxt, fecNames(), nfecs)
  If rc = 0 Then Exit For
Next
If rc <> 0 Then Exit Sub
lstFecNames.Clear
For i = 0 To nfecs - 1
  If (Len(fecNames(i)) > 0) And (fecNames(i) <> "ENS") Then lstFecNames.AddItem fecNames(i)
Next
If lstFecNames.ListCount > 0 Then
  lstFecNames.ListIndex = IIf(lstFecNamesIndex >= 0, lstFecNamesIndex, 0)
End If
End Sub

Sub fillContextCombo()
Dim rc As Integer, i As Integer
cmbContexts.Clear
For i = 0 To 2
  rc = GetEquipmentDeviceContexts(contexts(), ncontexts)
  If rc = 0 Then Exit For
Next
If rc Then
  MsgBox RPCERROR(rc)
  Exit Sub
End If
cmbContexts.AddItem "DEFAULT"
For i = 0 To ncontexts - 1
  cmbContexts.AddItem contexts(i)
Next
If cmbContexts.ListCount > 0 Then cmbContexts.ListIndex = 0
End Sub


Private Sub Form_Load()
Call fillContextCombo
End Sub

Private Sub lstDeviceServers_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = 2 Then
   PopupMenu srvOpts
End If
End Sub


Private Sub lstFecNames_Click()
Dim rc As Integer, i As Integer
Dim finfo As RPCFECINFO
Dim infoText As String
lstDeviceServers.Clear
infoText = "Information not available !"
For i = 0 To 2
'  rc = GetEquipmentDeviceServers(cmbContexts.text, lstFecNames.text, servers(), nservers)
  rc = GetFecInfoFromNameServer(lstFecNames.text, finfo, servers(), nservers)
  DoEvents
  If rc = 0 Then Exit For
Next
If rc Then
  If rc = link_not_open Then MsgBox RPCERROR(rc)
  Exit Sub
End If
infoText = prepareFecInfo(finfo)
fecInfoText.text = infoText

If nservers = 0 Then Exit Sub
For i = 0 To nservers - 1
  lstDeviceServers.AddItem servers(i)
Next
If lstDeviceServers.ListCount > 0 Then lstDeviceServers.ListIndex = 0
srvLabel.Caption = "Registered Device Servers for FEC " + lstFecNames.text + " :"

End Sub
Private Sub lstFecNames_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = 2 Then
   PopupMenu fecOpts
End If
End Sub


Private Sub pngSrv_Click()
pingSelectedDeviceServer
End Sub

Private Sub rmvFec_Click()
Call rmvSelectedFec
End Sub


Private Sub rmvSrv_Click()
Call rmvSelectedDeviceServer
End Sub


