Attribute VB_Name = "eMailSend"
Option Explicit

' SendMail function copied from http://www.activevb.de
' and modified by Karol, 30.05.2005

Public SMTPresult As String

Public Function SendMail(winSocket As WINSOCK, domain As String, smtp As String, fromName As String, _
    fromMail As String, toName As String, toMail As String, subject As _
    String, msgBody As String) As Boolean
                          
    Dim mailText As String, outTO As String, outFR As String
    Static mailing As Boolean
    
    If mailing = True Then Exit Function
    mailing = True
    

    If winSocket.State = sckClosed Then
        On Error GoTo err_handler
        
        winSocket.LocalPort = 0
        
        outFR = "mail from: " & fromMail & vbCrLf
        outTO = "rcpt to: " & toMail & vbCrLf & "data" & vbCrLf
        
        mailText = mailText & "From: " & fromName & " <" & fromMail & ">"
        mailText = mailText & vbCrLf & "Date: " & Format(date, "Ddd")
        mailText = mailText & ", " & Format(date, "dd Mmm YYYY") & " "
        mailText = mailText & Format(time, "hh:mm:ss") & " +0100" & vbCrLf
        mailText = mailText & "X-Mailer: Visual Basic Mailing Tester"
        mailText = mailText & vbCrLf & "To: " & toName & " <" & toMail & ">"
        mailText = mailText & vbCrLf & "Subject: " & subject & vbCrLf
        mailText = mailText & vbCrLf & msgBody & vbCrLf & vbCrLf & "." & vbCrLf
        
        With winSocket
            .Protocol = sckTCPProtocol
            .RemoteHost = smtp
            .RemotePort = 25
            .Connect
        
            If Not response("220") Then GoTo err_handler

        
            '''.SendData ("HELO " & Domain & vbCrLf)
            .SendData (domain & vbCrLf)
            If Not response("250") Then GoTo err_handler
                
            .SendData (outFR)
            If Not response("250") Then GoTo err_handler

            .SendData (outTO)
            If Not response("250") Then GoTo err_handler

            .SendData ("DATA" & vbCrLf)
            If Not response("354") Then GoTo err_handler

            .SendData (msgBody)
            If Not response("250") Then GoTo err_handler
        

            .SendData ("quit" & vbCrLf)
            If Not response("221") Then GoTo err_handler
        
            SendMail = True
        End With
    End If
err_handler:
    mailing = False
    winSocket.Close
    
    Exit Function
End Function


Private Function response(responseCode As String) As Boolean
    Dim t As Single, start As Single
    
    response = True
    start = timer()
    
    Do While Left(SMTPresult, 3) <> responseCode
        DoEvents
        t = timer
        If t < start Then start = 0 'midnight
            
        If t - start > 1 Then
            response = False
            Exit Do
        End If
    Loop
    SMTPresult = ""
    
End Function

